import pandas as pd
import datetime
import numpy as np
from pandas_datareader import data  
import pandas as pd
from urllib.request import urlopen
from bs4 import BeautifulSoup
import matplotlib.pyplot as plt
pd.set_option('display.width', 250)         #表示幅を変更
pd.set_option("display.max_columns", 25)    #最大表示列数
pd.set_option("display.max_colwidth", 80)   #列の最大文字数
pd.set_option("display.max_rows", 200)      #最大表示行数


def read_stockdata(code='7203.JP',start='2015-01-01',end='2020-07-25'):  # ■株データダウンロード_stooq_J725
    #!pip install pandas_datareader
    #from pandas_datareader import data  
    #import pandas as pd

    df=data.DataReader(code,'stooq',start,end)
    df=df.sort_index()  #indexの日付をソートする
    
    return df

def append_data(code1):
    #from urllib.request import urlopen
    #from bs4 import BeautifulSoup
    #import pandas as pd

    def cook(code):
      try:
          tgt = 'https://kabutan.jp/stock/kabuka?code=' + str(code)
          html = urlopen(tgt)
          bsObj = BeautifulSoup(html, 'html.parser')
          table = bsObj.findAll('table', {'class':'stock_kabuka0'})[0]
          rows = table.findAll('tr')
          for row in rows:
              rec = []
              for cell in row.findAll(['td', 'th']):
                  rec.append(cell.get_text())
              del rec[5:7]
              rec.insert(0, str(code) + '.JP')
          dish.append(rec)
          return 'Success'
      except Exception as e:
          return str(code) + ': ' + str(e)

    dish=[]
    l=[code1]
    [cook(i) for i in l]

    dish=pd.DataFrame(dish).rename(columns={0: 'code', 1: 'Date', 2:'Open', 3: 'High', 4: 'Low', 5:'Close', 6: 'Volume'})
    
    dish['Date']=pd.to_datetime('20'+dish['Date'],format='%Y-%m-%d %H:%M:%S')
    
    dish=dish.set_index('Date')

    return dish

def stock_graph(df,code_s):
    #import matplotlib.pyplot as plt

    date=df.index
    price=df['Close']
    plt.figure(figsize=(30,10))

    span01=5
    span02=25
    span03=75
    df['sma05']=price.rolling(window=span01).mean()
    df['sma25']=price.rolling(window=span02).mean()
    df['sma30']=price.rolling(window=span03).mean()

    plt.plot(date,price,label='7203',lw=5)
    plt.plot(date,df['sma05'],label='sma05')
    plt.plot(date,df['sma25'],label='sma25')
    plt.plot(date,df['sma30'],label='sma75')
    plt.title(code_s,color='blue',backgroundcolor='white',size=40,loc='center')
    plt.xlabel('date',color='black',size=30)
    plt.ylabel('price',color='black',size=30)
    plt.grid()
    plt.legend()

    plt.plot(date,price)
    plt.show()
    
    return df

def main(code_s='7203.JP',start='2016-01-01',graph_flg=True):
    #import pandas as pd
    #import datetime
    #import numpy as np

    #今日の日付を指定
    now = datetime.datetime.now()
    end=now.strftime("%Y-%m-%d")

    code=int(code_s[0:4])

    print(code_s,start ,end)
    df=read_stockdata(code_s,start,end)
    
    #最新の株価情報を取得
    df2=append_data(code)
    df2["Open"] = df2["Open"].str.replace(',','').astype(np.int)
    df2["High"] = df2["High"].str.replace(',','').astype(np.int)
    df2["Low"] = df2["Low"].str.replace(',','').astype(np.int)
    df2["Close"] = df2["Close"].str.replace(',','').astype(np.int)
    df2["Volume"] = df2["Volume"].str.replace(',','').astype(np.int)
    
    df=pd.concat([df, df2])   #結合
    
    grouped = df.groupby(level=0)  
    df = grouped.last() 

    df=df.drop('code', axis=1)
    #グラフの描画（データフレームとグラフタイトルを渡す）
    if graph_flg:
        df=stock_graph(df,code_s)
    return df
    
        
#■メインプログラム
if __name__  == '__main__':

    #code：銘柄コード番号.JP　の書式文字列を設定する
    #start:株価データの先頭期日
    df=main(code_s='7203.JP',start='1999-01-01',graph_flg=True)
    
    ######## ここにはいろいろ解析するコードを入れてもよい ###########
    print(df.head(10))
    print(df.tail(30))
    #################################################################
    
    a=input('何かキーを押してください')


